Index: org/postgresql/jdbc3/Jdbc3Array.java
===================================================================
RCS file: /cvsroot/jdbc/pgjdbc/org/postgresql/jdbc3/Jdbc3Array.java,v
retrieving revision 1.7
diff -c -r1.7 Jdbc3Array.java
*** org/postgresql/jdbc3/Jdbc3Array.java	2 Aug 2011 13:49:01 -0000	1.7
--- org/postgresql/jdbc3/Jdbc3Array.java	3 Oct 2011 21:25:50 -0000
***************
*** 21,26 ****
--- 21,31 ----
          super(conn, oid, fieldString);
      }
  
+     public Jdbc3Array(BaseConnection conn, int oid, byte[] fieldBytes) throws SQLException
+     {
+         super(conn, oid, fieldBytes);
+     }
+ 
      public Object getArray(Map map) throws SQLException
      {
          return getArrayImpl(map);
Index: org/postgresql/jdbc3/Jdbc3ResultSet.java
===================================================================
RCS file: /cvsroot/jdbc/pgjdbc/org/postgresql/jdbc3/Jdbc3ResultSet.java,v
retrieving revision 1.18
diff -c -r1.18 Jdbc3ResultSet.java
*** org/postgresql/jdbc3/Jdbc3ResultSet.java	2 Aug 2011 13:49:01 -0000	1.18
--- org/postgresql/jdbc3/Jdbc3ResultSet.java	3 Oct 2011 21:25:50 -0000
***************
*** 1,9 ****
  /*-------------------------------------------------------------------------
  *
! * Copyright (c) 2004-2011, PostgreSQL Global Development Group
  *
  * IDENTIFICATION
! *   $PostgreSQL: pgjdbc/org/postgresql/jdbc3/Jdbc3ResultSet.java,v 1.18 2011/08/02 13:49:01 davecramer Exp $
  *
  *-------------------------------------------------------------------------
  */
--- 1,9 ----
  /*-------------------------------------------------------------------------
  *
! * Copyright (c) 2004-2008, PostgreSQL Global Development Group
  *
  * IDENTIFICATION
! *   $PostgreSQL: pgjdbc/org/postgresql/jdbc3/Jdbc3ResultSet.java,v 1.17 2008/01/08 06:56:29 jurka Exp $
  *
  *-------------------------------------------------------------------------
  */
***************
*** 56,61 ****
--- 56,64 ----
      {
          checkResultSet(i);
          int oid = fields[i - 1].getOID();
+         if (isBinary(i)) {
+             return new Jdbc3Array(connection, oid, this_row[i - 1]);
+         }
          String value = getFixedString(i);
          return new Jdbc3Array(connection, oid, value);
      }
Index: org/postgresql/jdbc3g/Jdbc3gArray.java
===================================================================
RCS file: /cvsroot/jdbc/pgjdbc/org/postgresql/jdbc3g/Jdbc3gArray.java,v
retrieving revision 1.7
diff -c -r1.7 Jdbc3gArray.java
*** org/postgresql/jdbc3g/Jdbc3gArray.java	2 Aug 2011 13:50:28 -0000	1.7
--- org/postgresql/jdbc3g/Jdbc3gArray.java	3 Oct 2011 21:25:50 -0000
***************
*** 21,26 ****
--- 21,31 ----
          super(conn, oid, fieldString);
      }
  
+     public Jdbc3gArray(BaseConnection conn, int oid, byte[] fieldBytes) throws SQLException
+     {
+         super(conn, oid, fieldBytes);
+     }
+ 
      public Object getArray(Map < String, Class < ? >> map) throws SQLException
      {
          return getArrayImpl(map);
Index: org/postgresql/jdbc3g/Jdbc3gResultSet.java
===================================================================
RCS file: /cvsroot/jdbc/pgjdbc/org/postgresql/jdbc3g/Jdbc3gResultSet.java,v
retrieving revision 1.11
diff -c -r1.11 Jdbc3gResultSet.java
*** org/postgresql/jdbc3g/Jdbc3gResultSet.java	2 Aug 2011 13:50:28 -0000	1.11
--- org/postgresql/jdbc3g/Jdbc3gResultSet.java	3 Oct 2011 21:25:50 -0000
***************
*** 1,9 ****
  /*-------------------------------------------------------------------------
  *
! * Copyright (c) 2004-2011, PostgreSQL Global Development Group
  *
  * IDENTIFICATION
! *   $PostgreSQL: pgjdbc/org/postgresql/jdbc3g/Jdbc3gResultSet.java,v 1.11 2011/08/02 13:50:28 davecramer Exp $
  *
  *-------------------------------------------------------------------------
  */
--- 1,9 ----
  /*-------------------------------------------------------------------------
  *
! * Copyright (c) 2004-2008, PostgreSQL Global Development Group
  *
  * IDENTIFICATION
! *   $PostgreSQL: pgjdbc/org/postgresql/jdbc3g/Jdbc3gResultSet.java,v 1.10 2008/09/30 04:34:51 jurka Exp $
  *
  *-------------------------------------------------------------------------
  */
***************
*** 56,61 ****
--- 56,64 ----
      {
          checkResultSet(i);
          int oid = fields[i - 1].getOID();
+         if (isBinary(i)) {
+             return new Jdbc3gArray(connection, oid, this_row[i - 1]);
+         }
          String value = getFixedString(i);
          return new Jdbc3gArray(connection, oid, value);
      }
